diff --git a/ldap/servers/slapd/plugin_mmr.c b/ldap/servers/slapd/plugin_mmr.c
new file mode 100644
index 0000000..f581205
--- /dev/null
+++ b/ldap/servers/slapd/plugin_mmr.c
@@ -0,0 +1,71 @@
+/** BEGIN COPYRIGHT BLOCK
+ * Copyright (C) 2001 Sun Microsystems, Inc. Used by permission.
+ * Copyright (C) 2005 Red Hat, Inc.
+ * All rights reserved.
+ *
+ * License: GPL (version 3 or any later version).
+ * See LICENSE for details. 
+ * END COPYRIGHT BLOCK **/
+
+#ifdef HAVE_CONFIG_H
+#  include <config.h>
+#endif
+
+
+/*
+ * plugin_mmr.c - routines for calling mmr pre and postop plugins
+ */
+
+#include "slap.h"
+
+int
+plugin_call_mmr_plugin_preop ( Slapi_PBlock *pb, Slapi_Entry *e, int flags)
+{
+	struct slapdplugin	*p;
+	int			rc = LDAP_INSUFFICIENT_ACCESS;
+	Operation	*operation;
+
+	slapi_pblock_get (pb, SLAPI_OPERATION, &operation);
+
+	/* we don't perform acl check for internal operations  and if the plugin has set it not to be checked
+	if (operation_is_flag_set(operation, SLAPI_OP_FLAG_NO_ACCESS_CHECK|OP_FLAG_INTERNAL|OP_FLAG_REPLICATED|OP_FLAG_LEGACY_REPLICATION_DN))
+		return LDAP_SUCCESS;
+	*/
+
+	/* call the global plugins first and then the backend specific */
+	for ( p = get_plugin_list(PLUGIN_LIST_MMR); p != NULL; p = p->plg_next ) {
+		if (plugin_invoke_plugin_sdn (p, SLAPI_PLUGIN_MMR_BETXN_PREOP, pb,
+									  (Slapi_DN*)slapi_entry_get_sdn_const (e))){
+			rc = (*p->plg_mmr_betxn_preop)(pb, flags);
+			if ( rc != LDAP_SUCCESS ) break;
+		}
+	}
+
+	return rc;
+}
+
+int
+plugin_call_mmr_plugin_postop ( Slapi_PBlock *pb, Slapi_Entry *e, int flags)
+{
+	struct slapdplugin	*p;
+	int			rc = LDAP_INSUFFICIENT_ACCESS;
+	Operation	*operation;
+
+	slapi_pblock_get (pb, SLAPI_OPERATION, &operation);
+
+	/* we don't perform acl check for internal operations  and if the plugin has set it not to be checked
+	if (operation_is_flag_set(operation, SLAPI_OP_FLAG_NO_ACCESS_CHECK|OP_FLAG_INTERNAL|OP_FLAG_REPLICATED|OP_FLAG_LEGACY_REPLICATION_DN))
+		return LDAP_SUCCESS;
+	*/
+
+	/* call the global plugins first and then the backend specific */
+	for ( p = get_plugin_list(PLUGIN_LIST_MMR); p != NULL; p = p->plg_next ) {
+		if (plugin_invoke_plugin_sdn (p, SLAPI_PLUGIN_MMR_BETXN_POSTOP, pb,
+									  (Slapi_DN*)slapi_entry_get_sdn_const (e))){
+			rc = (*p->plg_mmr_betxn_postop)(pb, flags);
+			if ( rc != LDAP_SUCCESS ) break;
+		}
+	}
+
+	return rc;
+}
diff --git a/ldap/servers/slapd/proto-slap.h b/ldap/servers/slapd/proto-slap.h
index 2661ca8..cff7b43 100644
--- a/ldap/servers/slapd/proto-slap.h
+++ b/ldap/servers/slapd/proto-slap.h
@@ -941,6 +941,12 @@ int plugin_call_acl_mods_update(Slapi_PBlock *pb, int optype);
 int plugin_call_acl_verify_syntax(Slapi_PBlock *pb, Slapi_Entry *e, char **errbuf);
 
 /*
+ * plugin_mmr.c
+ */
+int plugin_call_mmr_plugin_preop ( Slapi_PBlock *pb, Slapi_Entry *e, int flags);
+int plugin_call_mmr_plugin_postop ( Slapi_PBlock *pb, Slapi_Entry *e, int flags);
+
+/*
  * pw_mgmt.c
  */
 void pw_init(void);
diff --git a/ldap/servers/slapd/slap.h b/ldap/servers/slapd/slap.h
index 17245ec..4463258 100644
--- a/ldap/servers/slapd/slap.h
+++ b/ldap/servers/slapd/slap.h
@@ -860,7 +860,8 @@ struct matchingRuleList
 #define PLUGIN_LIST_INDEX                    19
 #define PLUGIN_LIST_BETXNPREOPERATION        20
 #define PLUGIN_LIST_BETXNPOSTOPERATION       21
-#define PLUGIN_LIST_GLOBAL_MAX               22
+#define PLUGIN_LIST_MMR                      22
+#define PLUGIN_LIST_GLOBAL_MAX               23
 
 /* plugin configuration attributes */
 #define ATTR_PLUGIN_PATH                   "nsslapd-pluginPath"
@@ -1282,6 +1283,14 @@ struct slapdplugin
 #define plg_acl_mods_allowed plg_un.plg_un_acl.plg_un_acl_mods_allowed
 #define plg_acl_mods_update plg_un.plg_un_acl.plg_un_acl_mods_update
 
+        struct plg_un_mmr_struct
+        {
+            IFP plg_un_mmr_betxn_preop;
+            IFP plg_un_mmr_betxn_postop;
+        } plg_un_mmr;
+#define plg_mmr_betxn_preop 		plg_un.plg_un_mmr.plg_un_mmr_betxn_preop
+#define plg_mmr_betxn_postop 		plg_un.plg_un_mmr.plg_un_mmr_betxn_postop
+
         /* password storage scheme (kexcoff) */
         struct plg_un_pwd_storage_scheme_struct
         {
diff --git a/ldap/servers/slapd/slapi-plugin.h b/ldap/servers/slapd/slapi-plugin.h
index 6da0618..3397c63 100644
--- a/ldap/servers/slapd/slapi-plugin.h
+++ b/ldap/servers/slapd/slapi-plugin.h
@@ -6902,6 +6902,7 @@ slapi_timer_result slapi_timespec_expire_check(struct timespec *expire);
 #define SLAPI_PLUGIN_BETXNEXTENDEDOP          21
 #define SLAPI_PLUGIN_PREEXTOPERATION          22
 #define SLAPI_PLUGIN_POSTEXTOPERATION         23
+#define SLAPI_PLUGIN_MMR                      24
 
 /*
  * special return values for extended operation plugins (zero or positive
@@ -6920,6 +6921,13 @@ slapi_timer_result slapi_timespec_expire_check(struct timespec *expire);
                                  * Treat as SUCCESS, but skip the backend op.
                                  * Also, return SUCCESS to the client/supplier.
                                  * Necessary for the replication conflicts. */
+#define SLAPI_PLUGIN_NOOP_COMMIT -3 /* Special in be_pre_op/be_txn_pre_op.
+                                     * main op should be noop, but plugin made
+                                     * changes which need to be committed
+                                     */
+#define SLAPI_PLUGIN_NOOP_TOMBSTONE -4  /* Ignore the add and turn entry
+                                         * into tombstone
+                                         */
 
 /*
  * the following can be used as the second argument to the
@@ -6993,6 +7001,7 @@ slapi_timer_result slapi_timespec_expire_check(struct timespec *expire);
 /* urp flags */
 #define SLAPI_URP_NAMING_COLLISION_DN 286
 #define SLAPI_URP_TOMBSTONE_UNIQUEID  288
+#define SLAPI_URP_TOMBSTONE_CONFLICT_DN	293
 
 /* common to all plugins */
 #define SLAPI_PLUGIN              3
@@ -7192,6 +7201,10 @@ typedef struct slapi_plugindesc
 #define ACLPLUGIN_ACCESS_MODRDN               4
 #define ACLPLUGIN_ACCESS_GET_EFFECTIVE_RIGHTS 5
 
+/* MMR plugin functions and arguments */
+#define SLAPI_PLUGIN_MMR_BETXN_PREOP		761
+#define SLAPI_PLUGIN_MMR_BETXN_POSTOP		762
+
 /* Authorization types */
 #define SLAPI_BE_MAXNESTLEVEL 742
 #define SLAPI_CLIENT_DNS 745
diff --git a/ldap/servers/slapd/slapi-private.h b/ldap/servers/slapd/slapi-private.h
index 58f7a86..548d5ca 100644
--- a/ldap/servers/slapd/slapi-private.h
+++ b/ldap/servers/slapd/slapi-private.h
@@ -423,6 +423,8 @@ char *slapi_filter_to_string_internal(const struct slapi_filter *f, char *buf, s
 #define OP_FLAG_NEVER_CACHE 0x200000             /* never keep the entry in cache */
 #define OP_FLAG_TOMBSTONE_FIXUP 0x400000         /* operation is tombstone fixup op */
 #define OP_FLAG_BULK_IMPORT 0x800000             /* operation is bulk import */
+#define OP_FLAG_NOOP 0x01000000                  /* operation results from urp and
+                                                  * should be ignored */
 
 /* reverse search states */
 #define REV_STARTED 1
-- 
2.5.5

